Index: CMT/v1r25-branch/source/cmt_parser.cxx
===================================================================
--- CMT/v1r25-branch/source/cmt_parser.cxx	(revision 646)
+++ CMT/v1r25-branch/source/cmt_parser.cxx	(revision 664)
@@ -8100,5 +8698,146 @@
   SyntaxParser::parse_requirements (dir, &use);
 
-  if (Me.m_debug) cout << "reach_current_package2> current_tag=" << Me.m_current_tag << endl;
+  if (CmtError::has_pending_error ()) return 0;
+
+  if (Me.m_debug) cout << "use_current_package2> current_tag=" << Me.m_current_tag << endl;
+
+  return 1;
+}
+
+//----------------------------------------------------------
+int Cmt::use_extra_file (const cmt_string& file)
+{
+  if (!CmtSystem::test_file (file))
+    {
+      CmtError::set (CmtError::path_not_found, file);
+      return 0;
+    }
+
+  // (almost) Cmt::use_current_package ()
+  Use& use = Use::current ();
+  /*
+    Try to access the package.
+  */
+
+  if (Me.m_current_package == "cmt_standalone")
+    {
+      if ((Me.m_current_path != "") && (Me.m_current_path != Me.m_current_dir))
+//      if ((Me.m_current_path != "") && (Me.m_current_path != CmtSystem::pwd ()))
+        {
+          if (!CmtSystem::cd (Me.m_current_path))
+            {
+              CmtError::set (CmtError::package_not_found,
+                             "Cannot reach the path directory: "
+			     + Me.m_current_path);
+              return (0);
+            }
+        }
+      /*
+      if (!CmtSystem::test_file ("requirements"))
+        {
+          return (0);
+        }
+      */
+      Me.m_current_structuring_style = without_version_directory;
+      use.structuring_style = Me.m_current_structuring_style;
+      use.change_path (Me.m_current_path, Project::get_current ());
+      Me.m_current_access = DeveloperMode;
+    }
+  else if (Me.m_current_package != "")
+    {
+      if (!use.located ())
+	{
+	  //	  if (!use.move_to () && !use.move_to ("", true))
+	    //      if (!use.move_to ())
+	  if (!use.move_to ())
+	    {
+	      if (!CmtSystem::cd (Cmt::get_current_dir ()))
+		{
+		  CmtError::set (CmtError::file_access_error,
+				 Cmt::get_current_dir ()
+				 + " (use_extra_file)");
+		  return 0;
+		}
+	      if (!use.move_to ("", true))
+		{
+		  CmtError::set (CmtError::package_not_found, use.get_info ());
+		  return 0;
+		}
+	    }
+	  
+	  Me.m_current_path = use.real_path;
+	  Me.m_current_access = DeveloperMode;
+	}
+    }
+  else
+    {
+      //
+      // The cmt command has been given without explicit search for 
+      // a package. Thus it is expected that we are in the context of a
+      // true package.
+      //
+      //  This means that there should be a requirements file visible.
+      //
+      //  If this is not true, we'll make a try into ../cmt and then
+      // a last try into ../mgr
+      //
+
+      Me.m_current_access = DeveloperMode;
+      //...
+      configure_current_dir ();
+      build_prefix (Me.m_current_package, Me.m_current_prefix);
+      build_config (Me.m_current_prefix, Me.m_current_config);
+    }
+
+  /*
+  configure_current_dir ();
+  build_prefix (Me.m_current_package, Me.m_current_prefix);
+  build_config (Me.m_current_prefix, Me.m_current_config);
+  */
+
+  /*
+    Check Tag is always set up
+  */
+
+  if (Me.m_debug) cout << "use_extra_file0> current_tag=" << Me.m_current_tag << endl;
+
+  if (Me.m_current_tag == "")
+    {
+      cmt_string env;
+
+      env = CmtSystem::getenv (Me.m_current_config);
+      if (env != "")
+        {
+          Tag* tag;
+
+          tag = Tag::add (env, PriorityConfig, "current package", 0);
+          tag->mark (use.get_package_name ());
+	  //Me.m_current_tag = env;
+
+          //if (!Me.m_quiet) cerr << "use_extra_file1> current_tag=" << Me.m_current_tag << endl;
+
+        }
+    }
+
+  if (Me.m_debug)
+    {
+      cout << "pwd = " << CmtSystem::pwd () << endl;
+    }
+
+  /*
+    Work on the requirements file.
+  */
+
+  SyntaxParser::parse_requirements (file, &use);
+
+  if (CmtError::has_pending_error ()) return 0;
+
+  if (Me.m_debug) cout << "use_extra_file2> current_tag=" << Me.m_current_tag << endl;
+  return 1;
+}
+
+//----------------------------------------------------------
+int Cmt::apply_globals ()
+{
 
   /**
@@ -8131,141 +8870,7 @@
   Tag::restore_tree ();
 
-  return (1);
-}
-
-//----------------------------------------------------------
-int Cmt::use_extra_file (const cmt_string& file)
-{
-  if (!CmtSystem::test_file (file))
-    {
-      CmtError::set (CmtError::path_not_found, file);
-      return 0;
-    }
-
-  // (almost) Cmt::reach_current_package ()
-  Use& use = Use::current ();
-  /*
-    Try to access the package.
-  */
-
-  if (Me.m_current_package == "cmt_standalone")
-    {
-      if ((Me.m_current_path != "") && (Me.m_current_path != CmtSystem::pwd ()))
-        {
-          if (!CmtSystem::cd (Me.m_current_path))
-            {
-              CmtError::set (CmtError::package_not_found,
-                             "ReachCurrentPackage> Cannot reach the path directory");
-              return (0);
-            }
-        }
-      /*
-      if (!CmtSystem::test_file ("requirements"))
-        {
-          return (0);
-        }
-      */
-      Me.m_current_structuring_style = without_version_directory;
-    }
-  else if (Me.m_current_package != "")
-    {
-      if (!use.move_to () && !use.move_to ("", true))
-	//      if (!use.move_to ())
-        {
-          CmtError::set (CmtError::package_not_found,
-                         "ReachCurrentPackage> Cannot reach the path directory");
-	  //          return -1;
-	  return (0);
-        }
-
-      Me.m_current_path = use.real_path;
-    }
-  else
-    {
-      //
-      // The cmt command has been given without explicit search for 
-      // a package. Thus it is expected that we are in the context of a
-      // true package.
-      //
-      //  This means that there should be a requirements file visible.
-      //
-      //  If this is not true, we'll make a try into ../cmt and then
-      // a last try into ../mgr
-      //
-
-      //...
-    }
-
-  configure_current_dir ();
-  build_prefix (Me.m_current_package, Me.m_current_prefix);
-  build_config (Me.m_current_prefix, Me.m_current_config);
-
-  /*
-    Check Tag is always set up
-  */
-
-  if (Me.m_debug) cout << "use_extra_file0> current_tag=" << Me.m_current_tag << endl;
-
-  if (Me.m_current_tag == "")
-    {
-      cmt_string env;
-
-      env = CmtSystem::getenv (Me.m_current_config);
-      if (env != "")
-        {
-          Tag* tag;
-
-          tag = Tag::add (env, PriorityConfig, "reach current package", 0);
-          tag->mark (use.get_package_name ());
-	  //Me.m_current_tag = env;
-
-          //if (!Me.m_quiet) cerr << "use_extra_file1> current_tag=" << Me.m_current_tag << endl;
-
-        }
-    }
-
-  if (Me.m_debug)
-    {
-      cout << "pwd = " << CmtSystem::pwd () << endl;
-    }
-
-  /*
-    Work on the requirements file.
-  */
-
-  SyntaxParser::parse_requirements (file, &use);
-
-  if (Me.m_debug) cout << "use_extra_file2> current_tag=" << Me.m_current_tag << endl;
-
-  /**
-   *   It would be useful to change this mechanism. Instead of
-   *  applying all global patterns at once to all use contexts, it
-   *  would be much better to apply it at the end of each
-   *  requirements file parsing, and only in the context the
-   *  appropriate Use.
-   *
-   *   This would avoid the current flaw which is that when a global
-   *  pattern specifies a "private" definition, it is actually
-   *  applied in the scope context of the Current Use and not in
-   *  each individual Use. Therefore the private is lost.
-   *
-   *   However, this induces problems since some pattern definitions
-   *  are done AFTER the use statements, which will NOT receive the
-   *  pattern aplications.
-   *
-   *   Therefore it is decided to leave this "bad" mechanism until
-   *  everybody is aware of this constraint.
-   *
-   * 
-   */
-  Pattern::apply_all_globals ();
-
-  /*
-    Select all possible tags
-  */
-
-  Tag::restore_tree ();
-
-  return (1);
+  if (CmtError::has_pending_error ()) return 0;
+
+  return 1;
 }
 
@@ -9676,4 +10281,5 @@
 
 //----------------------------------------------------------
+/*
 void Cmt::set_current_access (AccessMode mode)
 {
@@ -9692,5 +10298,5 @@
   Me.m_scope_filtering_mode = mode;
 }
-
+*/
 //----------------------------------------------------------
 void Cmt::set_standard_macros ()
@@ -9836,5 +10442,5 @@
   builder.fill_for_constituent_macros ();
 }
-
+/*
 void Cmt::set_all_sets_done ()
 {
@@ -9846,5 +10452,5 @@
   Me.m_all_sets_done = false;
 }
-
+*/
 //----------------------------------------------------------
 void Cmt::use_cmt ()
@@ -9905,7 +10511,46 @@
   if (CmtSystem::test_file (f))
     {
-      use->m_located = true;
-    }
-  SyntaxParser::parse_requirements (f, use);
+      use->style = none_style;
+      use->structuring_style = without_version_directory;
+
+      if (name == CmtSystem::get_home_package () ||
+	  name == CmtSystem::get_user_context_package ())
+	{
+	  const Project::ProjectPtrVector& Ordered = Project::ordered_projects ();
+	  if (0 == Ordered.size ())
+	    {
+	      if (m_cmt_context.m_use_projects)
+		{
+		  CmtError::set(CmtError::configuration_error,
+				"No such ordered project: " + use->get_info ());
+		  return;
+		}
+	      else
+		{
+		  use->change_path (path);
+		}
+	    }
+	  else
+	    {
+	      if (name == CmtSystem::get_home_package ())
+		use->change_path (path, Ordered[Ordered.size () - 1]);
+	      else if (name == CmtSystem::get_user_context_package ())
+		use->change_path (path, Ordered[0]);
+	    }
+	}
+      else
+	{
+	  CmtMessage::verbose
+	    (CmtError::get_error_name (CmtError::configuration_error)
+	     + ": Unknown special use: " + use->get_info ());
+	  use->change_path (path);
+	}
+      //      use->m_located = true;
+      SyntaxParser::parse_requirements (f, use);
+    }
+  else
+    {
+      use->discard ();
+    }
 
   Me.m_recursive = recursive_copy;
@@ -9922,9 +10567,9 @@
     {
       const cmt_string& s = v[i];
-      if (s == "") continue;
+      if (s.size () == 0) continue;
 
       if (result.size () != 0) result += separator;
       //if (i > 0) result += separator;
-      result += v[i];
+      result += s;
     }
 }
Index: CMT/v1r25-branch/source/cmt_parser.h
===================================================================
--- CMT/v1r25-branch/source/cmt_parser.h	(revision 646)
+++ CMT/v1r25-branch/source/cmt_parser.h	(revision 664)
@@ -3,4 +3,5 @@
 // arnault@lal.in2p3.fr
 // Modified by garonne@lal.in2p3.fr
+// Modified by Grigory Rybkin
 // See the complete license in cmt_license.txt "http://www.cecill.info". 
 //-----------------------------------------------------------
Index: CMT/v1r25-branch/source/cmt_pattern.cxx
===================================================================
--- CMT/v1r25-branch/source/cmt_pattern.cxx	(revision 646)
+++ CMT/v1r25-branch/source/cmt_pattern.cxx	(revision 664)
@@ -2,4 +2,5 @@
 // Copyright Christian Arnault LAL-Orsay CNRS
 // arnault@lal.in2p3.fr
+// Modified by Grigory Rybkin
 // See the complete license in cmt_license.txt "http://www.cecill.info". 
 //-----------------------------------------------------------
@@ -771,5 +772,5 @@
       replacement.replace_all ("<version>", context_use->version.c_str ());
       replacement.replace_all ("<path>",    context_use->real_path.c_str ());
-
+      /*
       cmt_string cmtpath = "";
       cmt_string offset = "";
@@ -779,7 +780,9 @@
       Project* p = Project::find_by_cmtpath (cmtpath);
       if (p != 0)
+      */
+      if (const Project* p = context_use->get_project ())
         {
-          const cmt_string& n = p->get_name ();
-          replacement.replace_all ("<project>", n.c_str ());
+	  //          const cmt_string& n = p->get_name ();
+          replacement.replace_all ("<project>", p->get_name ().c_str ());
         }
 
Index: CMT/v1r25-branch/source/cmt_project.cxx
===================================================================
--- CMT/v1r25-branch/source/cmt_project.cxx	(revision 646)
+++ CMT/v1r25-branch/source/cmt_project.cxx	(revision 664)
@@ -1,7 +1,7 @@
-
 //-----------------------------------------------------------
 // Copyright Christian Arnault LAL-Orsay CNRS
 // arnault@lal.in2p3.fr
 // Modified by garonne@lal.in2p3.fr
+// Modified by Grigory Rybkin
 // See the complete license in cmt_license.txt "http://www.cecill.info". 
 //-----------------------------------------------------------
@@ -646,5 +646,6 @@
       project_use->m_hidden  = true;
       project_use->selected  = true;
-      project_use->m_located = true;
+      project_use->change_path (project->get_cmtpath(), project);
+      //      project_use->m_located = true;
       cmt_map <Use*, bool> visited;
       project_use->set_auto_imports(Unspecified, Off, visited);
@@ -864,6 +865,4 @@
   static ProjectVector& Projects = projects ();
 
-  Project* result = 0;
-
   for (int i = (Projects.size () - 1); i >= 0; i--)
     {
@@ -879,9 +878,9 @@
 	//      if (here_real.find (p.m_cmtpath_real) == 0) 
 	{
-	  result = &p;
-	}
-    }
-
-  return (result);
+	  return &p;
+	}
+    }
+
+  return 0;
 }
 
@@ -1523,5 +1522,187 @@
 
 //----------------------------------------------------------
-void Project::fill_selection (int depth, CmtSystem::cmt_string_vector& path_selections)
+/**
+ *  Fill with projects (pointers) for CMTPATH entries >=1 and <= depth
+ *  except for CMTUSERCONTEXT project or CMTHOME project
+ *  unless either is current project.
+ *  Special values of depth:
+ *   0: CMTUSERCONTEXT project only
+ *  -1: CMTHOME project only
+ *
+ *  @param depth in CMTPATH up to which fill
+ *  @param path_selections vector to fill
+ */
+void Project::fill_selection (int depth, ConstProjectPtrVector& path_selections)
+{
+  static ProjectPtrVector& Ordered = Project::ordered_projects ();
+  int curdepth = depth;
+  for (int i = 0; i < Ordered.size (); i++)
+    {
+      const Project* project = Ordered[i];
+      const cmt_string& src = project->get_cmtpath_source ();
+
+      if (src == "default path") continue;
+
+      if (depth > 0)
+	{
+	  // project for CMTPATH entries >=1 and <= depth
+	  // except for CMTUSERCONTEXT path or CMTHOME path
+	  // OR
+	  // CMTUSERCONTEXT path if it's current project
+	  // CMTHOME        path if it's current project
+	  if (i == 0
+	      && !project->is_current ()
+	      && src == "CMTUSERCONTEXT") continue;
+	  // this is CMTUSERCONTEXT
+	  if (i == Ordered.size () - 1
+	      && !project->is_current ()
+	      && src == "CMTHOME") continue;
+	  // this is CMTHOME
+	  path_selections.push_back (project);
+	  //cerr << "fill: " << i << ": " << project->get_cmtpath () << ": " << curdepth << endl;
+	  if (--curdepth == 0) break;
+	}
+      else if (depth == 0)
+	{
+	  // CMTUSERCONTEXT path only
+	  if (i == 0
+	      && src == "CMTUSERCONTEXT")
+	    {
+	      path_selections.push_back (project);
+	      break;
+	    }
+	}
+      else if (depth == -1)
+	{
+	  // CMTHOME path only
+	  if (i == Ordered.size () - 1
+	      && src == "CMTHOME")
+	    {
+	      path_selections.push_back (project);
+	      break;
+	    }
+	}
+    }
+}
+
+//----------------------------------------------------------
+// void Project::fill_selection (int depth, CmtSystem::cmt_string_vector& path_selections)
+// {
+//   static ProjectPtrVector& Ordered = Project::ordered_projects ();
+//   int curdepth = depth;
+//   for (int i = 0; i < Ordered.size (); i++)
+//     {
+//       const Project* project = Ordered[i];
+
+//       const cmt_string& p = project->get_cmtpath ();
+//       const cmt_string& pwd = project->get_cmtpath_pwd ();
+//       const cmt_string& p_real = project->get_cmtpath_real ();
+//       const cmt_string& src = project->get_cmtpath_source ();
+
+//       if (src == "default path") continue;
+
+//       if (depth > 0)
+// 	{
+// 	  // packages from CMTPATH entries >=1 and <= depth
+// 	  // except for CMTUSERCONTEXT path or CMTHOME path
+// 	  // OR
+// 	  // CMTUSERCONTEXT path if it's current project
+// 	  // CMTHOME        path if it's current project
+// 	  if (i == 0
+// 	      && !project->is_current ()
+// 	      && src == "CMTUSERCONTEXT") continue;
+// 	  // this is CMTUSERCONTEXT
+// 	  if (i = Ordered.size () - 1
+// 	      && !project->is_current ()
+// 	      && src == "CMTHOME") continue;
+// 	  // this is CMTHOME
+// 	  cmt_string& s1 = path_selections.add ();
+// 	  s1 = p;
+// 	  if (pwd != p)
+// 	    {
+// 	      cmt_string& s2 = path_selections.add ();
+// 	      s2 = pwd;
+// 	    }
+// 	  if (p_real != p && p_real != pwd)
+// 	    {
+// 	      cmt_string& s3 = path_selections.add ();
+// 	      s3 = p_real;
+// 	    }
+// 	  if (--curdepth == 0) break;
+// 	}
+//       else if (depth == 0)
+// 	{
+// 	  // CMTUSERCONTEXT path only
+// 	  if (i == 0
+// 	      && src == "CMTUSERCONTEXT")
+// 	    {
+// 	      cmt_string& s1 = path_selections.add ();
+// 	      s1 = p;
+// 	      if (pwd != p)
+// 		{
+// 		  cmt_string& s2 = path_selections.add ();
+// 		  s2 = pwd;
+// 		}
+// 	      if (p_real != p && p_real != pwd)
+// 		{
+// 		  cmt_string& s3 = path_selections.add ();
+// 		  s3 = p_real;
+// 		}
+// 	      break;
+// 	    }
+// 	}
+//       else if (depth == -1)
+// 	{
+// 	  // CMTHOME path only
+// 	  if (i = Ordered.size () - 1
+// 	      && src == "CMTHOME")
+// 	    {
+// 	      cmt_string& s1 = path_selections.add ();
+// 	      s1 = p;
+// 	      if (pwd != p)
+// 		{
+// 		  cmt_string& s2 = path_selections.add ();
+// 		  s2 = pwd;
+// 		}
+// 	      if (p_real != p && p_real != pwd)
+// 		{
+// 		  cmt_string& s3 = path_selections.add ();
+// 		  s3 = p_real;
+// 		}
+// 	      break;
+// 	    }
+// 	}
+// // 	  if (depth > 0)
+// // 	    {
+// // 	      cmt_string& s1 = path_selections.add ();
+// // 	      s1 = p;
+// // 	      if (pwd != p)
+// // 		{
+// // 		  cmt_string& s2 = path_selections.add ();
+// // 		  s2 = pwd;
+// // 		}
+// // 	      if (p_real != p && p_real != pwd)
+// // 		{
+// // 		  cmt_string& s3 = path_selections.add ();
+// // 		  s3 = p_real;
+// // 		}
+// // 	      if (src != "CMTHOME" && src != "CMTUSERCONTEXT")
+// // 		depth--;
+
+// // 	      if (depth == 0) break;
+// // 	    }
+
+//     }
+// }
+
+//----------------------------------------------------------
+/**
+ *  Fill with projects (pointers) for CMTUSERCONTEXT and CMTHOME projects
+ *  (if any exists)
+ *  unless either is current project.
+ *  
+ *  @param path_exclusions vector to fill
+ */
+void Project::fill_exclusion (ConstProjectPtrVector& path_exclusions)
 {
   static ProjectPtrVector& Ordered = Project::ordered_projects ();
@@ -1529,43 +1710,9 @@
     {
       const Project* project = Ordered[i];
-
-      const cmt_string& p = project->get_cmtpath ();
-      const cmt_string& pwd = project->get_cmtpath_pwd ();
-      const cmt_string& p_real = project->get_cmtpath_real ();
       const cmt_string& src = project->get_cmtpath_source ();
-      /*
-  static ProjectVector& Projects = projects ();
-
-  for (int i = 0; i < Projects.size (); i++)
-    {
-      Project& project = Projects[i];
-
-      const cmt_string& p = project.get_cmtpath ();
-      const cmt_string& pwd = project.get_cmtpath_pwd ();
-      const cmt_string& p_real = project.get_cmtpath_real ();
-      const cmt_string& src = project.get_cmtpath_source ();
-      */
-      if (src != "default path")
-	{
-	  if (depth > 0)
-	    {
-	      cmt_string& s1 = path_selections.add ();
-	      s1 = p;
-	      if (pwd != p)
-		{
-		  cmt_string& s2 = path_selections.add ();
-		  s2 = pwd;
-		}
-	      if (p_real != p && p_real != pwd)
-		{
-		  cmt_string& s3 = path_selections.add ();
-		  s3 = p_real;
-		}
-	      if (src != "CMTHOME" && src != "CMTUSERCONTEXT")
-		depth--;
-
-	      if (depth == 0) break;
-	    }
-	}
+
+      if (!project->is_current ()
+	  && (src == "CMTUSERCONTEXT" || src == "CMTHOME"))
+	path_exclusions.push_back (project);
     }
 }
@@ -1694,5 +1841,5 @@
 // 	    }
 
-	  if (path_real.find (p_real) != cmt_string::npos)
+	  if (path_real.find (p_real) == 0) //!= cmt_string::npos)
 	    {
 	      return (p);
@@ -1700,5 +1847,5 @@
 
 	  // To become the current area, a path must correspond to the current package
-	  if (path.find (w) != cmt_string::npos)
+	  if (path.find (w) == 0)// != cmt_string::npos)
 	    {
 	      return (p);
@@ -1706,4 +1853,5 @@
 	}
 
+	/* This code is never used since p is returned above
       if (p == w) continue;
 
@@ -1711,9 +1859,10 @@
       //      if (CmtSystem::test_directory (w))
 	{
-	  if (path.find (w) != cmt_string::npos)
+	  if (path.find (w) == 0)// != cmt_string::npos)
 	    {
 	      return (w);
 	    }
 	}
+	*/
     }
 
@@ -2362,10 +2511,23 @@
   use->get_package ()->remove_use (use);
   CmtSystem::cd (m_cmtpath_pwd);
-  if (use->move_to ("", true) &&
-      !CmtSystem::absolute_path (use->real_path))
-    {
-      use->change_path (m_cmtpath_pwd);
-    }
+  if (use->move_to ("", true))
+    {
+      if (use->get_realpath ().find (this->get_cmtpath_real ()) == 0)
+	use->set_project (this);
+    }
+  else
+    if (0 == CmtSystem::getenv ("CMTPEDANTIC").size () &&
+	0 == CmtSystem::getenv ("PEDANTIC").size ())
+      CmtMessage::warning
+	(CmtError::get_error_name (CmtError::configuration_error)
+	 + ": Cannot locate container: " + use->get_info ());
+    else
+      CmtError::set(CmtError::configuration_error,
+		    "Cannot locate container: " + use->get_info ());
+  
   CmtSystem::cd (m_cmtpath_pwd + CmtSystem::file_separator () + "cmt");
+
+  if (CmtError::get_last_error_code () == CmtError::configuration_error)
+    return;
 
   set_container_name (name);
Index: CMT/v1r25-branch/source/cmt_project.h
===================================================================
--- CMT/v1r25-branch/source/cmt_project.h	(revision 646)
+++ CMT/v1r25-branch/source/cmt_project.h	(revision 664)
@@ -3,4 +3,5 @@
 // arnault@lal.in2p3.fr
 // Modified by garonne@lal.in2p3.fr
+// Modified by Grigory Rybkin
 // See the complete license in cmt_license.txt "http://www.cecill.info". 
 //-----------------------------------------------------------
@@ -97,4 +98,5 @@
   typedef cmt_vector<Project> ProjectVector;
   typedef cmt_vector<Project*> ProjectPtrVector;
+  typedef cmt_vector<const Project*> ConstProjectPtrVector;
 
   static bool create (const cmt_string& name, 
@@ -120,5 +122,7 @@
   static const cmt_string& get_project_file_name ();
 
-  static void fill_selection (int depth, CmtSystem::cmt_string_vector& path_selections);
+  static void fill_selection (int depth, ConstProjectPtrVector& path_selections);
+  //  static void fill_selection (int depth, CmtSystem::cmt_string_vector& path_selections);
+  static void fill_exclusion (ConstProjectPtrVector& path_exclusions);
 
   static void broadcast (IProjectAction& action);
Index: CMT/v1r25-branch/source/cmt_regexp.cxx
===================================================================
--- CMT/v1r25-branch/source/cmt_regexp.cxx	(revision 646)
+++ CMT/v1r25-branch/source/cmt_regexp.cxx	(revision 664)
@@ -2,4 +2,5 @@
 // Copyright Christian Arnault LAL-Orsay CNRS
 // arnault@lal.in2p3.fr
+// Modified by Grigory Rybkin
 // See the complete license in cmt_license.txt "http://www.cecill.info". 
 //-----------------------------------------------------------
Index: CMT/v1r25-branch/source/cmt_regexp.h
===================================================================
--- CMT/v1r25-branch/source/cmt_regexp.h	(revision 646)
+++ CMT/v1r25-branch/source/cmt_regexp.h	(revision 664)
@@ -2,4 +2,5 @@
 // Copyright Christian Arnault LAL-Orsay CNRS
 // arnault@lal.in2p3.fr
+// Modified by Grigory Rybkin
 // See the complete license in cmt_license.txt "http://www.cecill.info". 
 //-----------------------------------------------------------
Index: CMT/v1r25-branch/source/cmt_std.h
===================================================================
--- CMT/v1r25-branch/source/cmt_std.h	(revision 646)
+++ CMT/v1r25-branch/source/cmt_std.h	(revision 664)
@@ -3,4 +3,5 @@
 // arnault@lal.in2p3.fr
 // Modified by garonne@lal.in2p3.fr
+// Modified by Grigory Rybkin
 // See the complete license in cmt_license.txt "http://www.cecill.info". 
 //-----------------------------------------------------------
Index: CMT/v1r25-branch/source/cmt_string.cxx
===================================================================
--- CMT/v1r25-branch/source/cmt_string.cxx	(revision 646)
+++ CMT/v1r25-branch/source/cmt_string.cxx	(revision 664)
@@ -2,4 +2,5 @@
 // Copyright Christian Arnault LAL-Orsay CNRS
 // arnault@lal.in2p3.fr
+// Modified by Grigory Rybkin
 // See the complete license in cmt_license.txt "http://www.cecill.info". 
 //-----------------------------------------------------------
Index: CMT/v1r25-branch/source/cmt_string.h
===================================================================
--- CMT/v1r25-branch/source/cmt_string.h	(revision 646)
+++ CMT/v1r25-branch/source/cmt_string.h	(revision 664)
@@ -2,4 +2,5 @@
 // Copyright Christian Arnault LAL-Orsay CNRS
 // arnault@lal.in2p3.fr
+// Modified by Grigory Rybkin
 // See the complete license in cmt_license.txt "http://www.cecill.info". 
 //-----------------------------------------------------------
